/* A lexical scanner generated by flex */

/* Scanner skeleton version:
 * $Header: /home/daffy/u0/vern/flex/RCS/flex.skl,v 2.91 96/09/10 16:58:48 vern Exp $
 */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5

#include <stdio.h>


/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>
#include <unistd.h>

/* Use prototypes in function declarations. */
#define YY_USE_PROTOS

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

#if __STDC__

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */

#ifdef __TURBOC__
 #pragma warn -rch
 #pragma warn -use
#include <io.h>
#include <stdlib.h>
#define YY_USE_CONST
#define YY_USE_PROTOS
#endif

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif


#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#define YY_BUF_SIZE 16384

typedef struct yy_buffer_state *YY_BUFFER_STATE;

extern int yyleng;
extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* The funky do-while in the following #define is used to turn the definition
 * int a single C statement (which needs a semi-colon terminator).  This
 * avoids problems with code like:
 *
 * 	if ( condition_holds )
 *		yyless( 5 );
 *	else
 *		do_something_else();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the yyless() call.
 */

/* Return all but the first 'n' matched characters back to the input stream. */

#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		*yy_cp = yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yytext_ptr )

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */
typedef unsigned int yy_size_t;


struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;
#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2
	};

static YY_BUFFER_STATE yy_current_buffer = 0;

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
#define YY_CURRENT_BUFFER yy_current_buffer


/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;

static int yy_n_chars;		/* number of characters read into yy_ch_buf */


int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 1;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart YY_PROTO(( FILE *input_file ));

void yy_switch_to_buffer YY_PROTO(( YY_BUFFER_STATE new_buffer ));
void yy_load_buffer_state YY_PROTO(( void ));
YY_BUFFER_STATE yy_create_buffer YY_PROTO(( FILE *file, int size ));
void yy_delete_buffer YY_PROTO(( YY_BUFFER_STATE b ));
void yy_init_buffer YY_PROTO(( YY_BUFFER_STATE b, FILE *file ));
void yy_flush_buffer YY_PROTO(( YY_BUFFER_STATE b ));
#define YY_FLUSH_BUFFER yy_flush_buffer( yy_current_buffer )

YY_BUFFER_STATE yy_scan_buffer YY_PROTO(( char *base, yy_size_t size ));
YY_BUFFER_STATE yy_scan_string YY_PROTO(( yyconst char *yy_str ));
YY_BUFFER_STATE yy_scan_bytes YY_PROTO(( yyconst char *bytes, int len ));

static void *yy_flex_alloc YY_PROTO(( yy_size_t ));
static void *yy_flex_realloc YY_PROTO(( void *, yy_size_t ));
static void yy_flex_free YY_PROTO(( void * ));

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (yy_current_buffer->yy_at_bol)

typedef unsigned char YY_CHAR;
FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;
typedef int yy_state_type;
extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state YY_PROTO(( void ));
static yy_state_type yy_try_NUL_trans YY_PROTO(( yy_state_type current_state ));
static int yy_get_next_buffer YY_PROTO(( void ));
static void yy_fatal_error YY_PROTO(( yyconst char msg[] ));

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yytext_ptr = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 70
#define YY_END_OF_BUFFER 71
static yyconst short int yy_accept[362] =
    {   0,
        0,    0,   64,   64,   71,   69,   61,   62,   69,   69,
       69,   69,   69,   69,   54,   69,   69,   69,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   69,   64,   65,
       66,   61,   49,    0,   59,    0,   60,   46,   57,   63,
       56,   54,    0,   52,   50,   48,   51,   53,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
       58,   58,   58,   58,   58,   58,   58,    0,    0,    0,
       47,   64,   65,   66,   67,   66,   68,    0,   56,    0,

        0,   55,   58,   58,   58,   58,   58,    8,   58,    6,
       11,   58,   58,   58,   58,   58,   58,   58,   12,   58,
       58,   58,   10,   58,   58,   58,    7,   58,   58,    9,
       58,   58,    0,    0,    0,    0,    0,    0,    0,   57,
        0,    0,   56,   58,   58,   58,   17,   58,   58,   58,
        0,   33,   19,   58,   18,    2,   58,   58,    1,   58,
       58,   58,   58,   58,   58,   58,   58,   58,   14,   58,
       58,   58,    0,    0,    0,    0,    0,    0,    0,   56,
       58,   58,   58,   58,   58,   58,   16,    0,   45,   15,
       58,   13,   58,   58,   58,   58,   58,   58,    0,   35,

       58,   58,   58,   58,    0,    0,    0,    0,    0,    0,
        0,   43,   58,    0,   58,   58,   58,   20,   58,   58,
       58,   58,   58,   58,   58,    0,    0,   32,   58,   58,
        0,    0,    0,    0,    0,    0,   58,    0,   58,   58,
       58,   58,   58,    0,   34,   58,   58,   58,   58,    0,
        0,    0,   42,   58,    0,    0,   39,    0,    0,   40,
        0,    0,   41,   58,    0,   58,   58,    0,   58,   58,
       58,   58,    0,   58,    0,    0,   58,    0,    0,    0,
        0,   44,    0,   58,   58,    0,   58,    0,   30,   25,
       58,    0,    0,   58,    0,    0,   58,    0,   36,    0,

       37,    0,   38,    4,   58,   58,    0,   58,   58,    0,
        0,   24,    0,    0,   58,    0,   29,   58,    0,   21,
       58,    0,    0,    0,    0,   27,    0,   23,    0,   58,
        0,    0,    0,    0,    0,   31,   58,    0,    0,    0,
        0,    0,    0,    0,    0,   28,    0,    0,    0,    0,
        5,    0,    0,    0,    0,    0,   26,    3,    0,   22,
        0
    } ;

static yyconst int yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    1,    1,    8,    1,    1,
        1,    9,   10,    1,   11,   12,   13,   14,   15,   16,
       16,   16,   16,   16,   16,   16,   16,    1,    1,   17,
       18,   19,    1,    1,   21,   22,   23,   24,   25,   26,
       27,   28,   29,   20,   30,   31,   32,   33,   34,   35,
       36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
        1,    1,    1,    1,   20,    1,   21,   22,   23,   24,

       25,   26,   27,   28,   29,   20,   30,   31,   32,   33,
       34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
       44,   45,    1,   46,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst int yy_meta[47] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    1,
        1,    1,    1,    3,    3,    3,    1,    1,    1,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    1
    } ;

static yyconst short int yy_base[368] =
    {   0,
        0,    0,   44,   45,  521,  522,   47,  522,  502,  513,
      515,  509,   41,  507,   46,   46,  497,   47,    0,  483,
       33,   25,   41,   47,  476,   39,   46,  491,  471,   48,
      470,   51,   56,   56,  498,  497,  496,  460,  502,  522,
       85,   85,  522,  498,  522,  500,  522,  522,   85,  522,
       88,   93,  101,  522,  522,  522,  522,  522,    0,  467,
      461,  471,  470,   48,  473,  473,  461,  473,  460,  459,
      463,  460,  455,  456,  461,  448,  454,  448,  442,  462,
      441,  450,  447,  442,  457,   86,  448,   87,   88,   89,
      522,  473,  522,  124,  522,  125,  522,  125,  128,  135,

      115,  140,  447,  441,  450,  441,  433,  441,  437,  155,
        0,  430,  433,  442,  441,  439,  429,  437,   75,  436,
      438,  438,    0,  434,  432,  431,  415,  415,  416,    0,
      425,  430,  410,  409,  408,  407,  406,  405,  146,  149,
      156,  160,  163,  423,  419,  412,    0,  402,  407,  414,
      178,  522,    0,  401,    0,    0,  179,  398,  415,  421,
      397,  396,  407,  409,  393,  392,  182,  390,    0,  388,
      401,  392,  392,  392,  390,  390,  388,  388,  173,  176,
      191,  397,  413,  379,  375,  381,    0,  197,  522,    0,
      376,    0,  383,  382,  373,  375,  379,  369,  200,  522,

      372,  201,  366,  377,  381,  377,  379,  375,  377,  373,
      204,  522,  360,  369,  374,  356,  354,    0,  353,  370,
      209,  359,  358,  363,  358,  212,   81,  522,  219,  346,
      360,  222,  359,  227,  358,  230,  338,  344,  351,  345,
      367,  349,  345,  231,  522,  346,  353,  362,  348,  340,
      336,  234,  522,  338,  331,  237,  522,  330,  240,  522,
      329,  249,  522,  252,  336,  331,  334,  323,  329,  255,
      337,  320,  117,  337,  332,  332,  334,  258,  259,  262,
      267,  522,  330,  314,  328,  307,  321,  270,  522,    0,
      324,  314,  326,  311,  298,  304,  290,  277,  522,  280,

      522,  285,  522,  522,  288,  305,  289,  300,  285,  294,
      283,    0,  294,  289,  314,  292,  522,  277,  280,    0,
      283,  280,  265,  250,  295,  522,  246,    0,  298,  244,
      231,  243,  211,  222,  307,  522,  242,  214,  194,  310,
      187,  193,  178,  179,  313,  522,  179,  161,  166,  156,
      522,  140,  136,  135,  123,  103,  522,  522,   74,  522,
      522,  331,  334,  337,   49,  340,  343
    } ;

static yyconst short int yy_def[368] =
    {   0,
      361,    1,  362,  362,  361,  361,  361,  361,  361,  363,
      364,  361,  361,  361,  361,  361,  361,  361,  365,  365,
      365,  365,  365,  365,  365,  365,  365,  365,  365,  365,
      365,  365,  365,  365,  365,  365,  365,  361,  366,  361,
      367,  361,  361,  363,  361,  364,  361,  361,  361,  361,
      361,  361,  361,  361,  361,  361,  361,  361,  365,  365,
      365,  365,  365,  365,  365,  365,  365,  365,  365,  365,
      365,  365,  365,  365,  365,  365,  365,  365,  365,  365,
      365,  365,  365,  365,  365,  365,  365,  361,  361,  361,
      361,  366,  361,  367,  361,  367,  361,  361,  361,  361,

      361,  361,  365,  365,  365,  365,  365,  365,  365,  365,
      365,  365,  365,  365,  365,  365,  365,  365,  365,  365,
      365,  365,  365,  365,  365,  365,  365,  365,  365,  365,
      365,  365,  361,  361,  361,  361,  361,  361,  361,  361,
      361,  361,  361,  365,  365,  365,  365,  365,  365,  365,
      361,  361,  365,  365,  365,  365,  365,  365,  365,  365,
      365,  365,  365,  365,  365,  365,  365,  365,  365,  365,
      365,  365,  361,  361,  361,  361,  361,  361,  361,  361,
      365,  365,  365,  365,  365,  365,  365,  361,  361,  365,
      365,  365,  365,  365,  365,  365,  365,  365,  361,  361,

      365,  365,  365,  365,  361,  361,  361,  361,  361,  361,
      361,  361,  365,  361,  365,  365,  365,  365,  365,  365,
      365,  365,  365,  365,  365,  361,  361,  361,  365,  365,
      361,  361,  361,  361,  361,  361,  365,  361,  365,  365,
      365,  365,  365,  361,  361,  365,  365,  365,  365,  361,
      361,  361,  361,  365,  361,  361,  361,  361,  361,  361,
      361,  361,  361,  365,  361,  365,  365,  361,  365,  365,
      365,  365,  361,  365,  361,  361,  365,  361,  361,  361,
      361,  361,  361,  365,  365,  361,  365,  361,  361,  365,
      365,  361,  361,  365,  361,  361,  365,  361,  361,  361,

      361,  361,  361,  361,  365,  365,  361,  365,  365,  361,
      361,  365,  361,  361,  365,  361,  361,  365,  361,  365,
      365,  361,  361,  361,  361,  361,  361,  365,  361,  365,
      361,  361,  361,  361,  361,  361,  365,  361,  361,  361,
      361,  361,  361,  361,  361,  361,  361,  361,  361,  361,
      361,  361,  361,  361,  361,  361,  361,  361,  361,  361,
        0,  361,  361,  361,  361,  361,  361
    } ;

static yyconst short int yy_nxt[569] =
    {   0,
        6,    7,    8,    7,    9,   10,   11,   12,    6,    6,
        6,   13,   14,   15,   15,   15,   16,   17,   18,   19,
       20,   21,   22,   19,   23,   24,   25,   26,   19,   19,
       27,   28,   29,   19,   30,   31,   32,   33,   34,   19,
       19,   19,   35,   36,   37,   38,   40,   40,   42,   63,
       42,   59,   41,   41,   49,   49,   49,   51,   64,   52,
       52,   52,   54,   55,   57,   58,   61,   68,   78,   62,
       53,   65,   72,   66,   74,   81,   86,   69,   70,   75,
      107,   79,   73,   67,   83,  108,   42,   95,   42,  160,
       82,   84,   87,   96,   85,  161,  360,   97,   49,   49,

       49,   99,   99,   99,   51,  250,   52,   52,   52,   98,
      101,  101,  100,  251,  102,  102,  102,   53,  130,  133,
      135,  137,  131,  134,  136,  138,   95,   95,  102,  102,
      102,  359,  361,   96,  139,  139,  361,   97,  140,  140,
      140,   99,   99,   99,  142,  142,  358,  292,  143,  143,
      143,  293,  141,  102,  102,  102,  151,  357,  151,  140,
      140,  140,  140,  140,  140,  179,  179,  356,  355,  180,
      180,  180,  152,  143,  143,  143,  143,  143,  143,  151,
      188,  151,  188,  199,  354,  199,  180,  180,  180,  180,
      180,  180,  211,  353,  211,  152,  189,  352,  188,  200,

      188,  199,  226,  199,  226,  211,  351,  211,  212,  350,
      244,  227,  244,  226,  189,  226,  349,  200,  228,  348,
      252,  212,  252,  256,  347,  256,  245,  344,  259,  228,
      259,  262,  244,  262,  244,  252,  253,  252,  256,  257,
      256,  259,  343,  259,  260,  342,  341,  263,  245,  340,
      262,  253,  262,  281,  257,  281,  288,  260,  288,  298,
      300,  298,  300,  302,  339,  302,  263,  338,  281,  282,
      281,  288,  289,  288,  337,  299,  301,  334,  298,  303,
      298,  300,  333,  300,  282,  332,  302,  289,  302,  316,
      325,  316,  325,  316,  299,  316,  325,  301,  325,  335,

      331,  335,  303,  330,  329,  317,  326,  328,  335,  317,
      335,  345,  326,  345,  345,  336,  345,  327,  324,  323,
      322,  321,  320,  319,  336,  318,  315,  346,  314,  313,
      346,   39,   39,   39,   44,   44,   44,   46,   46,   46,
       92,  312,   92,   94,   94,   94,  311,  310,  309,  308,
      307,  306,  305,  304,  297,  296,  295,  294,  291,  290,
      287,  286,  285,  284,  283,  280,  279,  278,  277,  276,
      275,  274,  273,  272,  271,  270,  269,  268,  267,  266,
      265,  264,  261,  258,  255,  254,  249,  248,  247,  246,
      243,  242,  241,  240,  239,  238,  237,  236,  235,  234,

      233,  232,  231,  230,  229,  225,  224,  223,  222,  221,
      220,  219,  218,  217,  216,  215,  214,  213,  210,  209,
      208,  207,  206,  205,  204,  203,  202,  201,  198,  197,
      196,  195,  194,  193,  192,  191,  190,  187,  186,  185,
      184,  183,  182,  181,  178,  177,  176,  175,  174,  173,
      172,  171,  170,  169,  168,  167,  166,  165,  164,  163,
      162,  159,  158,  157,  156,  155,  154,  153,  150,  149,
      148,  147,  146,  145,  144,   93,  132,  129,  128,  127,
      126,  125,  124,  123,  122,  121,  120,  119,  118,  117,
      116,  115,  114,  113,  112,  111,  110,  109,  106,  105,

      104,  103,   47,   45,   93,   91,   90,   89,   88,   80,
       77,   76,   71,   60,   56,   50,   48,   47,   45,   43,
      361,    5,  361,  361,  361,  361,  361,  361,  361,  361,
      361,  361,  361,  361,  361,  361,  361,  361,  361,  361,
      361,  361,  361,  361,  361,  361,  361,  361,  361,  361,
      361,  361,  361,  361,  361,  361,  361,  361,  361,  361,
      361,  361,  361,  361,  361,  361,  361,  361
    } ;

static yyconst short int yy_chk[569] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    3,    4,    7,   22,
        7,  365,    3,    4,   13,   13,   13,   15,   22,   15,
       15,   15,   16,   16,   18,   18,   21,   24,   30,   21,
       15,   23,   26,   23,   27,   32,   34,   24,   24,   27,
       64,   30,   26,   23,   33,   64,   42,   41,   42,  119,
       32,   33,   34,   41,   33,  119,  359,   41,   49,   49,

       49,   51,   51,   51,   52,  227,   52,   52,   52,   49,
       53,   53,   51,  227,   53,   53,   53,   52,   86,   88,
       89,   90,   86,   88,   89,   90,   94,   96,  101,  101,
      101,  356,   94,   96,   98,   98,   94,   96,   98,   98,
       98,   99,   99,   99,  100,  100,  355,  273,  100,  100,
      100,  273,   99,  102,  102,  102,  110,  354,  110,  139,
      139,  139,  140,  140,  140,  141,  141,  353,  352,  141,
      141,  141,  110,  142,  142,  142,  143,  143,  143,  151,
      157,  151,  157,  167,  350,  167,  179,  179,  179,  180,
      180,  180,  181,  349,  181,  151,  157,  348,  188,  167,

      188,  199,  202,  199,  202,  211,  347,  211,  181,  344,
      221,  202,  221,  226,  188,  226,  343,  199,  202,  342,
      229,  211,  229,  232,  341,  232,  221,  339,  234,  226,
      234,  236,  244,  236,  244,  252,  229,  252,  256,  232,
      256,  259,  338,  259,  234,  337,  334,  236,  244,  333,
      262,  252,  262,  264,  256,  264,  270,  259,  270,  278,
      279,  278,  279,  280,  332,  280,  262,  331,  281,  264,
      281,  288,  270,  288,  330,  278,  279,  327,  298,  280,
      298,  300,  324,  300,  281,  323,  302,  288,  302,  305,
      314,  305,  314,  316,  298,  316,  325,  300,  325,  329,

      322,  329,  302,  321,  319,  305,  314,  318,  335,  316,
      335,  340,  325,  340,  345,  329,  345,  315,  313,  311,
      310,  309,  308,  307,  335,  306,  297,  340,  296,  295,
      345,  362,  362,  362,  363,  363,  363,  364,  364,  364,
      366,  294,  366,  367,  367,  367,  293,  292,  291,  287,
      286,  285,  284,  283,  277,  276,  275,  274,  272,  271,
      269,  268,  267,  266,  265,  261,  258,  255,  254,  251,
      250,  249,  248,  247,  246,  243,  242,  241,  240,  239,
      238,  237,  235,  233,  231,  230,  225,  224,  223,  222,
      220,  219,  217,  216,  215,  214,  213,  210,  209,  208,

      207,  206,  205,  204,  203,  201,  198,  197,  196,  195,
      194,  193,  191,  186,  185,  184,  183,  182,  178,  177,
      176,  175,  174,  173,  172,  171,  170,  168,  166,  165,
      164,  163,  162,  161,  160,  159,  158,  154,  150,  149,
      148,  146,  145,  144,  138,  137,  136,  135,  134,  133,
      132,  131,  129,  128,  127,  126,  125,  124,  122,  121,
      120,  118,  117,  116,  115,  114,  113,  112,  109,  108,
      107,  106,  105,  104,  103,   92,   87,   85,   84,   83,
       82,   81,   80,   79,   78,   77,   76,   75,   74,   73,
       72,   71,   70,   69,   68,   67,   66,   65,   63,   62,

       61,   60,   46,   44,   39,   38,   37,   36,   35,   31,
       29,   28,   25,   20,   17,   14,   12,   11,   10,    9,
        5,  361,  361,  361,  361,  361,  361,  361,  361,  361,
      361,  361,  361,  361,  361,  361,  361,  361,  361,  361,
      361,  361,  361,  361,  361,  361,  361,  361,  361,  361,
      361,  361,  361,  361,  361,  361,  361,  361,  361,  361,
      361,  361,  361,  361,  361,  361,  361,  361
    } ;

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexer.l"
#define INITIAL 0
#line 2 "lexer.l"
/*
    This file is part of the FElt finite element analysis package.
    Copyright (C) 1993,1994 Jason I. Gobat and Darren C. Atkinson

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/************************************************************************
 * File:	lexer.l							*
 *									*
 * Description:	This file contains the flex specification for the	*
 *		lexical analyzer for the corduroy element generator.	*
 ************************************************************************/

# include <stdio.h>
# include <string.h>
# include "error.h"
# include "generator.h"

# ifdef DOS
# include "yxtab.h"
# else
# include "y.tab.h"
# endif

# undef atof
extern double atof ( );


static char *filename;
static void  update_line PROTO ((void));
#define comment 1


/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap YY_PROTO(( void ));
#else
extern int yywrap YY_PROTO(( void ));
#endif
#endif

#ifndef YY_NO_UNPUT
static void yyunput YY_PROTO(( int c, char *buf_ptr ));
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy YY_PROTO(( char *, yyconst char *, int ));
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen YY_PROTO(( yyconst char * ));
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput YY_PROTO(( void ));
#else
static int input YY_PROTO(( void ));
#endif
#endif

#if YY_STACK_USED
static int yy_start_stack_ptr = 0;
static int yy_start_stack_depth = 0;
static int *yy_start_stack = 0;
#ifndef YY_NO_PUSH_STATE
static void yy_push_state YY_PROTO(( int new_state ));
#endif
#ifndef YY_NO_POP_STATE
static void yy_pop_state YY_PROTO(( void ));
#endif
#ifndef YY_NO_TOP_STATE
static int yy_top_state YY_PROTO(( void ));
#endif

#else
#define YY_NO_PUSH_STATE 1
#define YY_NO_POP_STATE 1
#define YY_NO_TOP_STATE 1
#endif

#ifdef YY_MALLOC_DECL
YY_MALLOC_DECL
#else
#if __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else
/* Just try to get by without declaring the routines.  This will fail
 * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
 * or sizeof(void*) != sizeof(int).
 */
#endif
#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */

#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO (void) fwrite( yytext, yyleng, 1, yyout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( yy_current_buffer->yy_is_interactive ) \
		{ \
		int c = '*', n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else if ( ((result = fread( buf, 1, max_size, yyin )) == 0) \
		  && ferror( yyin ) ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );
#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL int yylex YY_PROTO(( void ))
#endif

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

YY_DECL
	{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;

#line 54 "lexer.l"




/* Section headings */



	if ( yy_init )
		{
		yy_init = 0;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! yy_start )
			yy_start = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! yy_current_buffer )
			yy_current_buffer =
				yy_create_buffer( yyin, YY_BUF_SIZE );

		yy_load_buffer_state();
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = yy_start;
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				yy_last_accepting_state = yy_current_state;
				yy_last_accepting_cpos = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 362 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 522 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = yy_last_accepting_cpos;
			yy_current_state = yy_last_accepting_state;
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;


do_action:	/* This label is used only to access EOF actions. */


		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = yy_hold_char;
			yy_cp = yy_last_accepting_cpos;
			yy_current_state = yy_last_accepting_state;
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 61 "lexer.l"
{return LINE;}
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 62 "lexer.l"
{return GRID;}
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 63 "lexer.l"
{return QUADGRID;}
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 64 "lexer.l"
{return BRICKGRID;}
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 65 "lexer.l"
{return TRIMESH;}
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 66 "lexer.l"
{return END;}
	YY_BREAK

/* Reserved words (in expression or right hand side of assignment) */

case 7:
YY_RULE_SETUP
#line 73 "lexer.l"
{return SIN;}
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 74 "lexer.l"
{return COS;}
	YY_BREAK
case 9:
YY_RULE_SETUP
#line 75 "lexer.l"
{return TAN;}
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 76 "lexer.l"
{return POW;}
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 77 "lexer.l"
{return EXP;}
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 78 "lexer.l"
{return LOG;}
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 79 "lexer.l"
{return LOG10;}
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 80 "lexer.l"
{return SQRT;}
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 81 "lexer.l"
{return HYPOT;}
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 82 "lexer.l"
{return FLOOR;}
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 83 "lexer.l"
{return CEIL;}
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 84 "lexer.l"
{return FMOD;}
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 85 "lexer.l"
{return FABS;}
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 86 "lexer.l"
{return LINEAR;}
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 87 "lexer.l"
{return LOGARITHMIC;}
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 88 "lexer.l"
{return REVERSE_LOGARITHMIC;}
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 89 "lexer.l"
{return COSINUSOIDAL;}
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 90 "lexer.l"
{return SINUSOIDAL;}
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 91 "lexer.l"
{return PARABOLIC;}
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 92 "lexer.l"
{return REVERSE_PARABOLIC;}
	YY_BREAK

/* Assignments */

case 27:
YY_RULE_SETUP
#line 98 "lexer.l"
{return NODE_EQ;}
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 99 "lexer.l"
{return ELEMENT_EQ;}
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 100 "lexer.l"
{return CONSTRAINT_EQ;}
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 101 "lexer.l"
{return MATERIAL_EQ;}
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 102 "lexer.l"
{return TYPE_EQ;}
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 103 "lexer.l"
{return START_EQ;}
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 104 "lexer.l"
{return END_EQ;}
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 105 "lexer.l"
{return NUMBER_EQ;}
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 106 "lexer.l"
{return RULE_EQ;}
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 107 "lexer.l"
{return X_NUMBER_EQ;}
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 108 "lexer.l"
{return Y_NUMBER_EQ;}
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 109 "lexer.l"
{return Z_NUMBER_EQ;}
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 110 "lexer.l"
{return X_RULE_EQ;}
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 111 "lexer.l"
{return Y_RULE_EQ;}
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 112 "lexer.l"
{return Z_RULE_EQ;}
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 113 "lexer.l"
{return TARGET_EQ;}
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 114 "lexer.l"
{return ALPHA_EQ;}
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 115 "lexer.l"
{return BOUNDARY_EQ;}
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 116 "lexer.l"
{return HOLE_EQ;}
	YY_BREAK

/* Operators */

case 46:
YY_RULE_SETUP
#line 123 "lexer.l"
{return AND;}
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 124 "lexer.l"
{return OR;}
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 125 "lexer.l"
{return EQUALS;}
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 126 "lexer.l"
{return NEQUAL;}
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 127 "lexer.l"
{return LT_EQ;}
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 128 "lexer.l"
{return GT_EQ;}
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 129 "lexer.l"
{return LSHIFT;}
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 130 "lexer.l"
{return RSHIFT;}
	YY_BREAK

/* Numbers and names */

case 54:
YY_RULE_SETUP
#line 137 "lexer.l"
{yylval.i = atoi (yytext); return INTEGER;}
	YY_BREAK
case 55:
YY_RULE_SETUP
#line 138 "lexer.l"
{yylval.d = atof (yytext); return DOUBLE;}
	YY_BREAK
case 56:
YY_RULE_SETUP
#line 139 "lexer.l"
{yylval.d = atof (yytext); return DOUBLE;}
	YY_BREAK
case 57:
YY_RULE_SETUP
#line 140 "lexer.l"
{yylval.d = atof (yytext); return DOUBLE;}
	YY_BREAK
case 58:
YY_RULE_SETUP
#line 142 "lexer.l"
{yylval.s = strdup (yytext); return NAME;}
	YY_BREAK
case 59:
YY_RULE_SETUP
#line 143 "lexer.l"
{yylval.s = strdup (yytext + 1);
				 yylval.s [yyleng - 2] = 0; return NAME;}
	YY_BREAK

/* Comments, white space, and remaining preprocessor lines (the comment
   rules are straight from the flex documentation). */

case 60:
*yy_cp = yy_hold_char; /* undo effects of setting up yytext */
yy_c_buf_p = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 152 "lexer.l"
{update_line ( );}
	YY_BREAK
case 61:
YY_RULE_SETUP
#line 153 "lexer.l"
{}
	YY_BREAK
case 62:
YY_RULE_SETUP
#line 154 "lexer.l"
{generator.line ++;}
	YY_BREAK
case 63:
YY_RULE_SETUP
#line 155 "lexer.l"
{BEGIN comment;}
	YY_BREAK
case 64:
YY_RULE_SETUP
#line 157 "lexer.l"
{}
	YY_BREAK
case 65:
YY_RULE_SETUP
#line 158 "lexer.l"
{generator.line ++;}
	YY_BREAK
case 66:
YY_RULE_SETUP
#line 159 "lexer.l"
{}
	YY_BREAK
case 67:
YY_RULE_SETUP
#line 160 "lexer.l"
{generator.line ++;}
	YY_BREAK
case 68:
YY_RULE_SETUP
#line 161 "lexer.l"
{BEGIN INITIAL;}
	YY_BREAK
case 69:
YY_RULE_SETUP
#line 163 "lexer.l"
{return *yytext;}
	YY_BREAK
case 70:
YY_RULE_SETUP
#line 165 "lexer.l"
ECHO;
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(comment):
	yyterminate();

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - yytext_ptr) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = yy_hold_char;
		YY_RESTORE_YY_MORE_OFFSET

		if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between yy_current_buffer and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			yy_n_chars = yy_current_buffer->yy_n_chars;
			yy_current_buffer->yy_input_file = yyin;
			yy_current_buffer->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state();

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = yytext_ptr + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++yy_c_buf_p;
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = yy_c_buf_p;
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer() )
			{
			case EOB_ACT_END_OF_FILE:
				{
				yy_did_buffer_switch_on_eof = 0;

				if ( yywrap() )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				yy_c_buf_p =
					yytext_ptr + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				yy_c_buf_p =
				&yy_current_buffer->yy_ch_buf[yy_n_chars];

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of yylex */


/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */

static int yy_get_next_buffer()
	{
	register char *dest = yy_current_buffer->yy_ch_buf;
	register char *source = yytext_ptr;
	register int number_to_move, i;
	int ret_val;

	if ( yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( yy_current_buffer->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) (yy_c_buf_p - yytext_ptr) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		yy_current_buffer->yy_n_chars = yy_n_chars = 0;

	else
		{
		int num_to_read =
			yy_current_buffer->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */
#ifdef YY_USES_REJECT
			YY_FATAL_ERROR(
"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );
#else

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = yy_current_buffer;

			int yy_c_buf_p_offset =
				(int) (yy_c_buf_p - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yy_flex_realloc( (void *) b->yy_ch_buf,
							 b->yy_buf_size + 2 );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = yy_current_buffer->yy_buf_size -
						number_to_move - 1;
#endif
			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&yy_current_buffer->yy_ch_buf[number_to_move]),
			yy_n_chars, num_to_read );

		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	if ( yy_n_chars == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			yy_current_buffer->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	yy_n_chars += number_to_move;
	yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	yytext_ptr = &yy_current_buffer->yy_ch_buf[0];

	return ret_val;
	}


/* yy_get_previous_state - get the state just before the EOB char was reached */

static yy_state_type yy_get_previous_state()
	{
	register yy_state_type yy_current_state;
	register char *yy_cp;

	yy_current_state = yy_start;

	for ( yy_cp = yytext_ptr + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			yy_last_accepting_state = yy_current_state;
			yy_last_accepting_cpos = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 362 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
	}


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */

#ifdef YY_USE_PROTOS
static yy_state_type yy_try_NUL_trans( yy_state_type yy_current_state )
#else
static yy_state_type yy_try_NUL_trans( yy_current_state )
yy_state_type yy_current_state;
#endif
	{
	register int yy_is_jam;
	register char *yy_cp = yy_c_buf_p;

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		yy_last_accepting_state = yy_current_state;
		yy_last_accepting_cpos = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 362 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 361);

	return yy_is_jam ? 0 : yy_current_state;
	}


#ifndef YY_NO_UNPUT
#ifdef YY_USE_PROTOS
static void yyunput( int c, register char *yy_bp )
#else
static void yyunput( c, yy_bp )
int c;
register char *yy_bp;
#endif
	{
	register char *yy_cp = yy_c_buf_p;

	/* undo effects of setting up yytext */
	*yy_cp = yy_hold_char;

	if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = yy_n_chars + 2;
		register char *dest = &yy_current_buffer->yy_ch_buf[
					yy_current_buffer->yy_buf_size + 2];
		register char *source =
				&yy_current_buffer->yy_ch_buf[number_to_move];

		while ( source > yy_current_buffer->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		yy_current_buffer->yy_n_chars =
			yy_n_chars = yy_current_buffer->yy_buf_size;

		if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;


	yytext_ptr = yy_bp;
	yy_hold_char = *yy_cp;
	yy_c_buf_p = yy_cp;
	}
#endif	/* ifndef YY_NO_UNPUT */


#ifdef __cplusplus
static int yyinput()
#else
static int input()
#endif
	{
	int c;

	*yy_c_buf_p = yy_hold_char;

	if ( *yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			/* This was really a NUL. */
			*yy_c_buf_p = '\0';

		else
			{ /* need more input */
			int offset = yy_c_buf_p - yytext_ptr;
			++yy_c_buf_p;

			switch ( yy_get_next_buffer() )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin );

					/* fall through */

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap() )
						return EOF;

					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					yy_c_buf_p = yytext_ptr + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) yy_c_buf_p;	/* cast for 8-bit char's */
	*yy_c_buf_p = '\0';	/* preserve yytext */
	yy_hold_char = *++yy_c_buf_p;


	return c;
	}


#ifdef YY_USE_PROTOS
void yyrestart( FILE *input_file )
#else
void yyrestart( input_file )
FILE *input_file;
#endif
	{
	if ( ! yy_current_buffer )
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE );

	yy_init_buffer( yy_current_buffer, input_file );
	yy_load_buffer_state();
	}


#ifdef YY_USE_PROTOS
void yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
#else
void yy_switch_to_buffer( new_buffer )
YY_BUFFER_STATE new_buffer;
#endif
	{
	if ( yy_current_buffer == new_buffer )
		return;

	if ( yy_current_buffer )
		{
		/* Flush out information for old buffer. */
		*yy_c_buf_p = yy_hold_char;
		yy_current_buffer->yy_buf_pos = yy_c_buf_p;
		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	yy_current_buffer = new_buffer;
	yy_load_buffer_state();

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yy_did_buffer_switch_on_eof = 1;
	}


#ifdef YY_USE_PROTOS
void yy_load_buffer_state( void )
#else
void yy_load_buffer_state()
#endif
	{
	yy_n_chars = yy_current_buffer->yy_n_chars;
	yytext_ptr = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
	yyin = yy_current_buffer->yy_input_file;
	yy_hold_char = *yy_c_buf_p;
	}


#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_create_buffer( FILE *file, int size )
#else
YY_BUFFER_STATE yy_create_buffer( file, size )
FILE *file;
int size;
#endif
	{
	YY_BUFFER_STATE b;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yy_flex_alloc( b->yy_buf_size + 2 );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
	}


#ifdef YY_USE_PROTOS
void yy_delete_buffer( YY_BUFFER_STATE b )
#else
void yy_delete_buffer( b )
YY_BUFFER_STATE b;
#endif
	{
	if ( ! b )
		return;

	if ( b == yy_current_buffer )
		yy_current_buffer = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yy_flex_free( (void *) b->yy_ch_buf );

	yy_flex_free( (void *) b );
	}


#ifndef YY_ALWAYS_INTERACTIVE
#ifndef YY_NEVER_INTERACTIVE
extern int isatty YY_PROTO(( int ));
#endif
#endif

#ifdef YY_USE_PROTOS
void yy_init_buffer( YY_BUFFER_STATE b, FILE *file )
#else
void yy_init_buffer( b, file )
YY_BUFFER_STATE b;
FILE *file;
#endif


	{
	yy_flush_buffer( b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

#if YY_ALWAYS_INTERACTIVE
	b->yy_is_interactive = 1;
#else
#if YY_NEVER_INTERACTIVE
	b->yy_is_interactive = 0;
#else
	b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
#endif
#endif
	}


#ifdef YY_USE_PROTOS
void yy_flush_buffer( YY_BUFFER_STATE b )
#else
void yy_flush_buffer( b )
YY_BUFFER_STATE b;
#endif

	{
	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == yy_current_buffer )
		yy_load_buffer_state();
	}


#ifndef YY_NO_SCAN_BUFFER
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_buffer( char *base, yy_size_t size )
#else
YY_BUFFER_STATE yy_scan_buffer( base, size )
char *base;
yy_size_t size;
#endif
	{
	YY_BUFFER_STATE b;

	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer( b );

	return b;
	}
#endif


#ifndef YY_NO_SCAN_STRING
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_string( yyconst char *yy_str )
#else
YY_BUFFER_STATE yy_scan_string( yy_str )
yyconst char *yy_str;
#endif
	{
	int len;
	for ( len = 0; yy_str[len]; ++len )
		;

	return yy_scan_bytes( yy_str, len );
	}
#endif


#ifndef YY_NO_SCAN_BYTES
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_bytes( yyconst char *bytes, int len )
#else
YY_BUFFER_STATE yy_scan_bytes( bytes, len )
yyconst char *bytes;
int len;
#endif
	{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;

	/* Get memory for full buffer, including space for trailing EOB's. */
	n = len + 2;
	buf = (char *) yy_flex_alloc( n );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < len; ++i )
		buf[i] = bytes[i];

	buf[len] = buf[len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer( buf, n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
	}
#endif


#ifndef YY_NO_PUSH_STATE
#ifdef YY_USE_PROTOS
static void yy_push_state( int new_state )
#else
static void yy_push_state( new_state )
int new_state;
#endif
	{
	if ( yy_start_stack_ptr >= yy_start_stack_depth )
		{
		yy_size_t new_size;

		yy_start_stack_depth += YY_START_STACK_INCR;
		new_size = yy_start_stack_depth * sizeof( int );

		if ( ! yy_start_stack )
			yy_start_stack = (int *) yy_flex_alloc( new_size );

		else
			yy_start_stack = (int *) yy_flex_realloc(
					(void *) yy_start_stack, new_size );

		if ( ! yy_start_stack )
			YY_FATAL_ERROR(
			"out of memory expanding start-condition stack" );
		}

	yy_start_stack[yy_start_stack_ptr++] = YY_START;

	BEGIN(new_state);
	}
#endif


#ifndef YY_NO_POP_STATE
static void yy_pop_state()
	{
	if ( --yy_start_stack_ptr < 0 )
		YY_FATAL_ERROR( "start-condition stack underflow" );

	BEGIN(yy_start_stack[yy_start_stack_ptr]);
	}
#endif


#ifndef YY_NO_TOP_STATE
static int yy_top_state()
	{
	return yy_start_stack[yy_start_stack_ptr - 1];
	}
#endif

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

#ifdef YY_USE_PROTOS
static void yy_fatal_error( yyconst char msg[] )
#else
static void yy_fatal_error( msg )
char msg[];
#endif
	{
	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
	}



/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		yytext[yyleng] = yy_hold_char; \
		yy_c_buf_p = yytext + n; \
		yy_hold_char = *yy_c_buf_p; \
		*yy_c_buf_p = '\0'; \
		yyleng = n; \
		} \
	while ( 0 )


/* Internal utility routines. */

#ifndef yytext_ptr
#ifdef YY_USE_PROTOS
static void yy_flex_strncpy( char *s1, yyconst char *s2, int n )
#else
static void yy_flex_strncpy( s1, s2, n )
char *s1;
yyconst char *s2;
int n;
#endif
	{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
	}
#endif

#ifdef YY_NEED_STRLEN
#ifdef YY_USE_PROTOS
static int yy_flex_strlen( yyconst char *s )
#else
static int yy_flex_strlen( s )
yyconst char *s;
#endif
	{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
	}
#endif


#ifdef YY_USE_PROTOS
static void *yy_flex_alloc( yy_size_t size )
#else
static void *yy_flex_alloc( size )
yy_size_t size;
#endif
	{
	return (void *) malloc( size );
	}

#ifdef YY_USE_PROTOS
static void *yy_flex_realloc( void *ptr, yy_size_t size )
#else
static void *yy_flex_realloc( ptr, size )
void *ptr;
yy_size_t size;
#endif
	{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
	}

#ifdef YY_USE_PROTOS
static void yy_flex_free( void *ptr )
#else
static void yy_flex_free( ptr )
void *ptr;
#endif
	{
	free( ptr );
	}

#if YY_MAIN
int main()
	{
	yylex();
	return 0;
	}
#endif
#line 165 "lexer.l"


/************************************************************************
 * Function:	yyerror							*
 *									*
 * Description:	Writes a syntax error message reporting the unexpected	*
 *		token.							*
 ************************************************************************/

void yyerror (msg)
    char *msg;
{
    extern int yychar;


    if (yychar)
	error ("parse error before `%s'", yytext);
    else
	error ("parse error before end of input");
}


/************************************************************************
 * Function:	init_lexer						*
 *									*
 * Description:	Initializes the lexer for a new file.			*
 ************************************************************************/

void init_lexer (fp)
    FILE *fp;
{
    static int first_time = 1;


    if (first_time) {
	first_time = 0;
	yyin = fp;
    } else
	yyrestart (fp);

    filename = generator.filename;
}


/************************************************************************
 * Function:	update_line						*
 *									*
 * Description:	Updates the current line and file from a preprocessor	*
 *		directive.						*
 ************************************************************************/

static void update_line ( )
{
    char       *ptr1;
    char       *ptr2;
    int		line;
    static char include_filename [256];


    ptr2 = include_filename;
    line = strtol (yytext + 1, &ptr1, 10) - 1;

    if (ptr1) {
	generator.line = line;

	while (*ptr1 && *ptr1 ++ != '"');

	if (*ptr1)
	    generator.filename = filename;

	while (*ptr1 && *ptr1 != '"')
	    *ptr2 ++ = *ptr1 ++;

	*ptr2 = 0;
	if (ptr2 != include_filename)
	    generator.filename = include_filename;
    }
}

# undef yywrap
int yywrap ( ) {
    if (0) unput (0);
    return 1;
}
